%global srcname nose
%global _description %{expand:
A deprecated test runner for Python.

See https://nose.readthedocs.io/en/latest/testing.html for more}

Summary:        Deprecated test runner for Python
Name:           python-%{srcname}
Version:        1.3.7
Release:        7%{?dist}
License:        LGPLv2+ and Public Domain
URL:            https://nose.readthedocs.org/en/latest/
Source0:        http://pypi.python.org/packages/source/n/nose/nose-%{version}.tar.gz

Patch3000:      python-nose-coverage4.patch
Patch3001:      python-nose-py35.patch
Patch3002:      python-nose-unicode.patch
Patch3003:      python-nose-readunicode.patch
Patch3004:      python-nose-py36.patch
Patch3005:      python-nose-py38.patch
Patch3006:      python-nose-no-use_2to3.patch
Patch3007:      python-nose-py311.patch
Patch3008:      python-nose-py311-doctest.patch

BuildRequires:  dos2unix

BuildArch:      noarch

%description %_description

%package -n python3-%{srcname}
Summary:        %{summary}
BuildRequires:  python3-devel python3-setuptools python3-coverage
BuildRequires:  /usr/bin/2to3
Requires:       python3-setuptools

%description -n python3-%{srcname} %_description

%prep
%autosetup -N -n %{srcname}-%{version}
%autopatch -p1 -M 3007
%if "%{python3_version}" >= "3.11"
%patch 3008 -p1
%endif
dos2unix examples/attrib_plugin.py

%build
2to3 %{?_smp_mflags} --write --nobackups --no-diffs .
2to3 %{?_smp_mflags} --write --nobackups --no-diffs -d $(find -name '*.rst')
%py3_build

%install
mkdir -p %{buildroot}%{_mandir}/man1
%py3_install
mv %{buildroot}%{_bindir}/nosetests{,-%{python3_version}}
ln -sf nosetests-%{python3_version} %{buildroot}%{_bindir}/nosetests-3
mv %{buildroot}%{_prefix}/man/man1/nosetests.1 %{buildroot}%{_mandir}/man1/nosetests-%{python3_version}.1
ln -sf nosetests-%{python3_version}.1 %{buildroot}%{_mandir}/man1/nosetests-3.1
ln -sf nosetests-3 %{buildroot}%{_bindir}/nosetests
ln -sf nosetests-3.1 %{buildroot}%{_mandir}/man1/nosetests.1

%check
%{__python3} setup.py build_tests
%{__python3} selftest.py

%files -n python3-%{srcname}
%license lgpl.txt
%doc AUTHORS CHANGELOG NEWS README.txt
%{_bindir}/nosetests
%{_bindir}/nosetests-3
%{_bindir}/nosetests-%{python3_version}
%{python3_sitelib}/nose-*.egg-info/
%{python3_sitelib}/nose/
%{_mandir}/man1/nosetests.1*
%{_mandir}/man1/nosetests-3.1*
%{_mandir}/man1/nosetests-%{python3_version}.1*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.7-7
- Rebuilt for loongarch release

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.7-6
- Rebuilt for python 3.11

* Tue Sep 12 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.3.7-5
- Some fixes for python3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.7-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.7-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 29 2022 Shuo Wang <abushwang@tencent.com> - 1.3.7-1
- initial build
